// ManagedLib.h

#pragma once

namespace ManagedLib
{
using namespace System;

// The [Serializable] attribute is required for the class' methods and properties to be
// accessible across the app domain border. If some classes you intend to access in the
// wrapped library don't feature this attribute, you may need to add another wrapper level
// that exposes [Serializable] wrapper classes inside the managed lib app domain.

[Serializable]
public ref class ManagedClass
{
public:
  ManagedClass() : m_abyDummy(gcnew array<Byte>(16 * 1024 * 1024))
  {}

  void SayHello();

private:
  // This member is merely here to bloat the object a bit, so its memory footprint is
  // clearly visible in the chart:

  array<Byte> ^m_abyDummy;
};

}
