// NativeWrapper.cpp

#include "stdafx.h"

#define BUILDING_WRAPPER_DLL

#include "NativeWrapper.h"

#ifndef _MANAGED
#error Must be compiled with CLR support
#endif

// In the demo solution, this project has a project reference to ManagedLib. In a real-life
// scenario with a 3rd-party .NET library DLL, that would either be an assembly reference to
// that DLL or simply a #using directive (note the #).
//
// No need to #include ManagedLib.h: The prototype information is implicitly imported by
// referencing the .NET library DLL.

using namespace System;

private ref class ManagedClassProxy
{
public:
  static property ManagedLib::ManagedClass ^Instance
  {
    ManagedLib::ManagedClass ^get()
    {
      if (!s_instance) {
        s_apdManagedLibDomain = AppDomain::CreateDomain("Managed Lib Domain");
        s_instance = safe_cast<ManagedLib::ManagedClass ^>(s_apdManagedLibDomain->
          CreateInstanceAndUnwrap("ManagedLib, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null",
          "ManagedLib.ManagedClass"));
      }
      return s_instance;
    }
  }

public:
  static void Unload()
  {
    AppDomain::Unload(s_apdManagedLibDomain);
  }

private:
  static AppDomain ^s_apdManagedLibDomain;
  static ManagedLib::ManagedClass ^s_instance;
};

void WINAPI NativeHelloWrapper()
{
  ManagedClassProxy::Instance->SayHello();
}

EXPORTS void WINAPI UnloadManagedLib()
{
  ManagedClassProxy::Unload();
}
